import numpy as np


def activation(x):
    if x >= 0.5:
        return 1
    else:
        return 0


x = np.array([[0, 0], [0, 1], [1, 0], [1, 1]])
y = np.array([0, 1, 1, 1])
N = 4
p = 2
ni = 0.75
w = np.random.rand(p) * 0.05
y_est = np.zeros(N)
Er = np.zeros(N)

# first try
E = 0
for k in range(N):
    a = 0
    for j in range(p):
        a = a + x[k, j] * w[j]
    y_est[k] = activation(a)
    E += abs(y[k] - y_est[k])

# next tries
while E > 0.0001:
    E = 0
    for k in range(N):
        a = 0
        for j in range(p):
            step = ni * (y[k] - y_est[k]) * x[k, j]
            w[j] += step
            print (step)
            a = a + x[k, j] * w[j]
        y_est[k] = activation(a)
        E += abs(y[k] - y_est[k])
    print(w, E)
